Summary:	Hugs 98: The Nottingham and Yale Haskell system
Name:		hugs98
Version:	20021120
%define real_ver Nov2002
Release:	%mkrel 8
Source0:	http://cvs.haskell.org/Hugs/downloads/hugs98-Nov2002.tar.bz2
Source1:	http://www.cse.ogi.edu/PacSoft/projects/Hugs/downloads/libs.tar.gz
Source2:	http://haskell.cs.yale.edu/haskell-mode/haskell-mode-1.44.tar.bz2
Patch0:     hugs98-lvalue.patch
Url:		http://www.haskell.org/hugs/
License:	Artistic
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:	ncurses-devel readline-devel
Group:		Development/Other

%description
A Haskell interpreter and programming environment for developing cool
Haskell programs.

This release is largely conformant with Haskell 98, including
monad and record syntax, newtypes, strictness annotations, and
modules.  In addition, it comes packaged with the libraries defined
in the most recent version of the Haskell Library Report and with
extension libraries which are compatible with GHC 3.0.

%prep
%setup -q -n %{name}-%{real_ver}
%setup -q -c -n %{name}-%{real_ver}/docs/libs -T -D -a 1

#restore %{name}
%setup -q -n %{name}-%{real_ver} -T -D
%patch0 -p0 -b .lvalue

%build
cd src/unix
%configure --with-readline --libdir %{_datadir} # force to install in /usr/share/hugs instead of /usr/lib/hugs
cd .. ; %make OPTFLAGS="%{optflags}"

%install
rm -rf $RPM_BUILD_ROOT

(cd src ; %makeinstall libdir=$RPM_BUILD_ROOT%{_datadir})
install -d $RPM_BUILD_ROOT%{_mandir}/man1
install -m 644 docs/hugs.1 $RPM_BUILD_ROOT%{_mandir}/man1

find docs -name "*~" -o -name .cvsignore | xargs rm -f

install -d $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp/
(cd $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp ; 
 tar xfj %{SOURCE2} ;
 # fix errors
 perl -pi -e 's/\(enum-from-to/(haskell-enum-from-to/g' *.el
)

install -d $RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d
cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d/%{name}.el
(autoload 'haskell-mode "haskell-mode" "Major mode for editing Haskell scripts." t)
(autoload 'literate-haskell-mode "haskell-mode" "Major mode for editing literate Haskell scripts." t)
(add-hook 'haskell-mode-hook 'turn-on-haskell-font-lock)
(add-hook 'haskell-mode-hook 'turn-on-haskell-decl-scan)
(add-hook 'haskell-mode-hook 'turn-on-haskell-doc-mode)
(add-hook 'haskell-mode-hook 'turn-on-haskell-indent)
(add-hook 'haskell-mode-hook 'turn-on-haskell-hugs)
(add-to-list 'auto-mode-alist '("\\\\.[hg]s$"  . haskell-mode))
(add-to-list 'auto-mode-alist '("\\\\.hi$"     . haskell-mode))
(add-to-list 'auto-mode-alist '("\\\\.l[hg]s$" . literate-haskell-mode))
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc Install Readme docs
%{_bindir}/*
%{_mandir}/man1/*
%{_datadir}/hugs
%{_datadir}/emacs/site-lisp/*
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/*

%changelog
* Sat Nov 04 2006 Texstar <texstar@houston.rr.com> 20021120-8pclos2007
- Build for PCLinuxOS 2007

